Index: trunk/source/Lib/TLibCommon/TComSlice.h
===================================================================
--- trunk/source/Lib/TLibCommon/TComSlice.h	(revision 210)
+++ trunk/source/Lib/TLibCommon/TComSlice.h	(revision 296)
@@ -54,5 +54,5 @@
 class TComDepthMapGenerator;
 #endif
-#if HHI_INTER_VIEW_RESIDUAL_PRED
+#if H3D_IVRP
 class TComResidualGenerator;
 #endif
@@ -68,5 +68,4 @@
 // ====================================================================================================================
 
-#if RPS_IN_SPS
 /// Reference Picture Set class
 class TComReferencePictureSet
@@ -142,5 +141,4 @@
   Void setNumberOfReferencePictureSets(Int numberOfReferencePictureSets);
 };
-#endif
 
 #if VIDYO_VPS_INTEGRATION|QC_MVHEVC_B0046
@@ -179,5 +177,7 @@
   UInt        m_uiMaxDecPicBuffering[MAX_TLAYER]; 
   UInt        m_uiMaxLatencyIncrease[MAX_TLAYER];
-  
+#if INTER_VIEW_VECTOR_SCALING_C0115
+  Bool          m_bIVScalingFlag;
+#endif
 public:
   TComVPS();
@@ -213,4 +213,8 @@
   Void    setDependentLayer(UInt v, UInt layer)                     { m_uiDependentLayer[layer] = v;    }
   UInt    getDependentLayer(UInt layer)                             { return m_uiDependentLayer[layer]; }
+#endif
+#if INTER_VIEW_VECTOR_SCALING_C0115
+  Bool getIVScalingFlag( )                                   { return m_bIVScalingFlag; }
+  Void setIVScalingFlag(Bool b)                              { m_bIVScalingFlag = b;    }
 #endif
   Void    setNumReorderPics(UInt v, UInt tLayer)                { m_numReorderPics[tLayer] = v;    }
@@ -270,5 +274,4 @@
   UInt        m_picWidthInLumaSamples;
   UInt        m_picHeightInLumaSamples;
-#if PIC_CROPPING
   Bool        m_picCroppingFlag;
   Int         m_picCropLeftOffset;
@@ -276,7 +279,4 @@
   Int         m_picCropTopOffset;
   Int         m_picCropBottomOffset;
-#else
-  Int         m_aiPad[2];
-#endif
   UInt        m_uiMaxCUWidth;
   UInt        m_uiMaxCUHeight;
@@ -284,14 +284,7 @@
   UInt        m_uiMinTrDepth;
   UInt        m_uiMaxTrDepth;
-#if RPS_IN_SPS
   TComRPSList* m_RPSList;
   Bool        m_bLongTermRefsPresent;
-#endif
-#if H0567_DPB_PARAMETERS_PER_TEMPORAL_LAYER
   Int         m_numReorderPics[MAX_TLAYER];
-#else
-  Int         m_maxNumberOfReferencePictures;
-  Int         m_numReorderFrames;
-#endif
   
   Int         m_iNumberOfUsableInterViewRefs;
@@ -309,10 +302,5 @@
   Bool        m_useAMP;
   Bool        m_bUseALF;
-#if LCU_SYNTAX_ALF
   Bool        m_bALFCoefInSlice;
-#endif
-#if !PIC_CROPPING
-  Bool        m_bUsePAD;
-#endif
   Bool        m_bUseLMChroma; // JL:
 
@@ -321,8 +309,6 @@
   Bool        m_useNSQT;
   
-#if H0412_REF_PIC_LIST_RESTRICTION
   Bool        m_restrictedRefPicListsFlag;
   Bool        m_listsModificationPresentFlag;
-#endif
 
   // Parameter
@@ -330,8 +316,6 @@
   UInt        m_uiBitDepth;
   UInt        m_uiBitIncrement;
-#if H0736_AVC_STYLE_QP_RANGE
   Int         m_qpBDOffsetY;
   Int         m_qpBDOffsetC;
-#endif
 
 #if LOSSLESS_CODING
@@ -375,18 +359,11 @@
 
   Bool        m_scalingListEnabledFlag;
-#if H0567_DPB_PARAMETERS_PER_TEMPORAL_LAYER
   UInt        m_uiMaxDecPicBuffering[MAX_TLAYER]; 
   UInt        m_uiMaxLatencyIncrease[MAX_TLAYER];
-#else
-  UInt        m_uiMaxDecFrameBuffering; 
-  UInt        m_uiMaxLatencyIncrease;
-#endif
 
   Bool        m_useDF;
 
-#if TILES_WPP_ENTRY_POINT_SIGNALLING
   UInt        m_tilesOrEntropyCodingSyncIdc;
   Int         m_numSubstreams;
-#endif
 
 #if HHI_DMM_WEDGE_INTRA || HHI_DMM_PRED_TEX
@@ -409,8 +386,8 @@
 #endif
 
-#if HHI_INTER_VIEW_MOTION_PRED
+#if H3D_IVMP
   UInt  m_uiMultiviewMvPredMode;
 #endif
-#if HHI_INTER_VIEW_RESIDUAL_PRED
+#if H3D_IVRP
   UInt  m_uiMultiviewResPredMode;
 #endif
@@ -419,5 +396,5 @@
   TComDepthMapGenerator* m_pcDepthMapGenerator;
 #endif
-#if HHI_INTER_VIEW_RESIDUAL_PRED
+#if H3D_IVRP
   TComResidualGenerator* m_pcResidualGenerator;
 #endif
@@ -446,5 +423,4 @@
   UInt getPicHeightInLumaSamples      ()         { return  m_picHeightInLumaSamples;   }
 
-#if PIC_CROPPING
   Bool getPicCroppingFlag() const          { return m_picCroppingFlag; }
   Void setPicCroppingFlag(Bool val)        { m_picCroppingFlag = val; }
@@ -457,5 +433,4 @@
   Int  getPicCropBottomOffset() const      { return m_picCropBottomOffset; }
   Void setPicCropBottomOffset(Int val)     { m_picCropBottomOffset = val; }
-#endif
 
   Void setMaxCUWidth  ( UInt u ) { m_uiMaxCUWidth = u;      }
@@ -489,22 +464,10 @@
   UInt getQuadtreeTUMaxDepthInter()         { return m_uiQuadtreeTUMaxDepthInter; }
   UInt getQuadtreeTUMaxDepthIntra()         { return m_uiQuadtreeTUMaxDepthIntra; }
-#if !PIC_CROPPING
-  Void setPad         (Int iPad[2]) { m_aiPad[0] = iPad[0]; m_aiPad[1] = iPad[1]; }
-#endif
-#if H0567_DPB_PARAMETERS_PER_TEMPORAL_LAYER
   Void setNumReorderPics(Int i, UInt tlayer)              { m_numReorderPics[tlayer] = i;    }
   Int  getNumReorderPics(UInt tlayer)                     { return m_numReorderPics[tlayer]; }
-#else
-  Void setMaxNumberOfReferencePictures( Int u )  { m_maxNumberOfReferencePictures = u;    }
-  Int  getMaxNumberOfReferencePictures()         { return m_maxNumberOfReferencePictures; }
-  Void setNumReorderFrames( Int i )              { m_numReorderFrames = i;    }
-  Int  getNumReorderFrames()                     { return m_numReorderFrames; }
-#endif
-#if RPS_IN_SPS
   Void      setRPSList( TComRPSList* RPSList )   { m_RPSList = RPSList;       }
   TComRPSList* getRPSList()                      { return m_RPSList;          }
   Bool      getLongTermRefsPresent()         { return m_bLongTermRefsPresent; }
   Void      setLongTermRefsPresent(Bool b)   { m_bLongTermRefsPresent=b;      }
-#endif
 
   Void setNumberOfUsableInterViewRefs( Int number )      { m_iNumberOfUsableInterViewRefs = number;    }
@@ -513,10 +476,4 @@
   Int  getUsableInterViewRef( Int pos )                  { return m_aiUsableInterViewRefs[pos];        }
 
-#if !PIC_CROPPING
-  Void setPadX        ( Int  u ) { m_aiPad[0] = u; }
-  Void setPadY        ( Int  u ) { m_aiPad[1] = u; }
-  Int  getPad         ( Int  u ) { assert(u < 2); return m_aiPad[u];}
-  Int* getPad         ( )        { return m_aiPad; }
-#endif
   
   // physical transform
@@ -526,13 +483,7 @@
   // Tool list
   Bool getUseALF      ()         { return m_bUseALF;        }
-#if LCU_SYNTAX_ALF
   Void setUseALFCoefInSlice(Bool b) {m_bALFCoefInSlice = b;}
   Bool getUseALFCoefInSlice()    {return m_bALFCoefInSlice;}
-#endif
-
-#if !PIC_CROPPING
-  Bool getUsePAD      ()         { return m_bUsePAD;        }
-  Void setUsePAD      ( Bool b ) { m_bUsePAD   = b;         }
-#endif
+
   Void setUseALF      ( Bool b ) { m_bUseALF  = b;          }
   Void setUseLComb    (Bool b)   { m_bUseLComb = b;         }
@@ -551,10 +502,8 @@
   Void setUseNSQT( Bool b ) { m_useNSQT = b; }
   
-#if H0412_REF_PIC_LIST_RESTRICTION
   Bool getRestrictedRefPicListsFlag    ()          { return m_restrictedRefPicListsFlag;   }
   Void setRestrictedRefPicListsFlag    ( Bool b )  { m_restrictedRefPicListsFlag = b;      }
   Bool getListsModificationPresentFlag ()          { return m_listsModificationPresentFlag; }
   Void setListsModificationPresentFlag ( Bool b )  { m_listsModificationPresentFlag = b;    }
-#endif
 
   // AMVP mode (for each depth)
@@ -571,10 +520,8 @@
   UInt      getBitIncrement ()         { return m_uiBitIncrement; }
   Void      setBitIncrement ( UInt u ) { m_uiBitIncrement = u;    }
-#if H0736_AVC_STYLE_QP_RANGE
   Int       getQpBDOffsetY  ()             { return m_qpBDOffsetY;   }
   Void      setQpBDOffsetY  ( Int value  ) { m_qpBDOffsetY = value;  }
   Int       getQpBDOffsetC  ()             { return m_qpBDOffsetC;   }
   Void      setQpBDOffsetC  ( Int value  ) { m_qpBDOffsetC = value;  }
-#endif
 
   Void      setLFCrossSliceBoundaryFlag     ( Bool   bValue  )    { m_bLFCrossSliceBoundaryFlag = bValue; }
@@ -619,8 +566,4 @@
   Void     setUniformSpacingIdr             ( Int i )           { m_iUniformSpacingIdr = i; }
   Int      getUniformSpacingIdr             ()                  { return m_iUniformSpacingIdr; }
-#if !REMOVE_TILE_DEPENDENCE
-  Void     setTileBoundaryIndependenceIdr   ( Int i )           { m_iTileBoundaryIndependenceIdr = i; }
-  Int      getTileBoundaryIndependenceIdr   ()                  { return m_iTileBoundaryIndependenceIdr; }
-#endif
   Void     setNumColumnsMinus1              ( Int i )           { m_iNumColumnsMinus1 = i; }
   Int      getNumColumnsMinus1              ()                  { return m_iNumColumnsMinus1; }
@@ -655,21 +598,12 @@
   Bool getScalingListFlag       ()         { return m_scalingListEnabledFlag;     }
   Void setScalingListFlag       ( Bool b ) { m_scalingListEnabledFlag  = b;       }
-#if H0567_DPB_PARAMETERS_PER_TEMPORAL_LAYER
   UInt getMaxDecPicBuffering  (UInt tlayer)            { return m_uiMaxDecPicBuffering[tlayer]; }
   Void setMaxDecPicBuffering  ( UInt ui, UInt tlayer ) { m_uiMaxDecPicBuffering[tlayer] = ui;   }
   UInt getMaxLatencyIncrease  (UInt tlayer)            { return m_uiMaxLatencyIncrease[tlayer];   }
   Void setMaxLatencyIncrease  ( UInt ui , UInt tlayer) { m_uiMaxLatencyIncrease[tlayer] = ui;      }
-#else
-  UInt getMaxDecFrameBuffering  ()            { return m_uiMaxDecFrameBuffering; }
-  Void setMaxDecFrameBuffering  ( UInt ui )   { m_uiMaxDecFrameBuffering = ui;   }
-  UInt getMaxLatencyIncrease    ()            { return m_uiMaxLatencyIncrease;   }
-  Void setMaxLatencyIncrease    ( UInt ui )   { m_uiMaxLatencyIncrease= ui;      }
-#endif
-#if TILES_WPP_ENTRY_POINT_SIGNALLING
   UInt getTilesOrEntropyCodingSyncIdc ()                    { return m_tilesOrEntropyCodingSyncIdc;   }
   Void setTilesOrEntropyCodingSyncIdc ( UInt val )          { m_tilesOrEntropyCodingSyncIdc = val;    }
   Int  getNumSubstreams               ()                    { return m_numSubstreams;                 }
   Void setNumSubstreams               ( Int numSubstreams ) { m_numSubstreams = numSubstreams;        }
-#endif
 
 #if HHI_DMM_WEDGE_INTRA || HHI_DMM_PRED_TEX
@@ -705,5 +639,5 @@
   Void setPredDepthMapGeneration( UInt uiViewId, Bool bIsDepth, UInt uiPdmGenMode = 0, UInt uiPdmMvPredMode = 0, UInt uiPdmPrec = 0, Int** aaiPdmScaleNomDelta = 0, Int** aaiPdmOffset = 0 );
 #endif
-#if HHI_INTER_VIEW_RESIDUAL_PRED
+#if H3D_IVRP
   Void  setMultiviewResPredMode  ( UInt uiResPrdMode ) { m_uiMultiviewResPredMode = uiResPrdMode; }
 #endif
@@ -716,8 +650,8 @@
 #endif
 
-#if HHI_INTER_VIEW_MOTION_PRED
+#if H3D_IVMP
   UInt  getMultiviewMvPredMode   ()          { return m_uiMultiviewMvPredMode;    }
 #endif
-#if HHI_INTER_VIEW_RESIDUAL_PRED
+#if H3D_IVRP
   UInt  getMultiviewResPredMode  ()          { return m_uiMultiviewResPredMode;   }
 #endif
@@ -727,5 +661,5 @@
   TComDepthMapGenerator*  getDepthMapGenerator()                                              { return m_pcDepthMapGenerator; }
 #endif
-#if HHI_INTER_VIEW_RESIDUAL_PRED
+#if H3D_IVRP
   Void                    setResidualGenerator( TComResidualGenerator* pcResidualGenerator )  { m_pcResidualGenerator = pcResidualGenerator; }
   TComResidualGenerator*  getResidualGenerator()                                              { return m_pcResidualGenerator; }
@@ -733,79 +667,4 @@
 };
 
-#if !RPS_IN_SPS
-/// Reference Picture Set class
-class TComReferencePictureSet
-{
-private:
-  Int m_numberOfPictures;
-  Int m_numberOfNegativePictures;
-  Int m_numberOfPositivePictures;
-  Int m_numberOfLongtermPictures;
-  Int  m_deltaPOC[MAX_NUM_REF_PICS];
-  Int  m_POC[MAX_NUM_REF_PICS];
-  Bool m_used[MAX_NUM_REF_PICS];
-  Bool m_interRPSPrediction;
-  Int  m_deltaRIdxMinus1;   
-  Int  m_deltaRPS; 
-  Int  m_numRefIdc; 
-  Int  m_refIdc[MAX_NUM_REF_PICS+1];
-
-public:
-  TComReferencePictureSet();
-  virtual ~TComReferencePictureSet();
-
-  Void setUsed(Int bufferNum, Bool used);
-  Void setDeltaPOC(Int bufferNum, Int deltaPOC);
-  Void setPOC(Int bufferNum, Int deltaPOC);
-  Void setNumberOfPictures(Int numberOfPictures);
-
-  Int  getUsed(Int bufferNum);
-  Int  getDeltaPOC(Int bufferNum);
-  Int  getPOC(Int bufferNum);
-  Int  getNumberOfPictures();
-
-  Void setNumberOfNegativePictures(Int number)  { m_numberOfNegativePictures = number; }
-  Int  getNumberOfNegativePictures()            { return m_numberOfNegativePictures; }
-  Void setNumberOfPositivePictures(Int number)  { m_numberOfPositivePictures = number; }
-  Int  getNumberOfPositivePictures()            { return m_numberOfPositivePictures; }
-  Void setNumberOfLongtermPictures(Int number)  { m_numberOfLongtermPictures = number; }
-  Int  getNumberOfLongtermPictures()            { return m_numberOfLongtermPictures; }
-
-  Void setInterRPSPrediction(Bool flag)         { m_interRPSPrediction = flag; }
-  Bool getInterRPSPrediction()                  { return m_interRPSPrediction; }
-  Void setDeltaRIdxMinus1(Int x)                { m_deltaRIdxMinus1 = x; }
-  Int  getDeltaRIdxMinus1()                     { return m_deltaRIdxMinus1; }
-  Void setDeltaRPS(Int x)                       { m_deltaRPS = x; }
-  Int  getDeltaRPS()                            { return m_deltaRPS; }
-  Void setNumRefIdc(Int x)                      { m_numRefIdc = x; }
-  Int  getNumRefIdc()                           { return m_numRefIdc; }
-
-  Void setRefIdc(Int bufferNum, Int refIdc);
-  Int  getRefIdc(Int bufferNum);
-
-  Void sortDeltaPOC();
-  Void printDeltaPOC();
-};
-
-/// Reference Picture Set set class
-class TComRPSList
-{
-private:
-  Int  m_numberOfReferencePictureSets;
-  TComReferencePictureSet* m_referencePictureSets;
-  
-public:
-  TComRPSList();
-  virtual ~TComRPSList();
-  
-  Void  create  (Int numberOfEntries);
-  Void  destroy ();
-
-
-  TComReferencePictureSet* getReferencePictureSet(Int referencePictureSetNum);
-  Int getNumberOfReferencePictureSets();
-  Void setNumberOfReferencePictureSets(Int numberOfReferencePictureSets);
-};
-#endif
 
 /// Reference Picture Lists class
@@ -815,13 +674,5 @@
   UInt      m_bRefPicListModificationFlagL0;  
   UInt      m_bRefPicListModificationFlagL1;  
-#if !H0137_0138_LIST_MODIFICATION
-  UInt      m_uiNumberOfRefPicListModificationsL0;
-  UInt      m_uiNumberOfRefPicListModificationsL1;
-  UInt      m_ListIdcL0[32];
-#endif
   UInt      m_RefPicSetIdxL0[32];
-#if !H0137_0138_LIST_MODIFICATION
-  UInt      m_ListIdcL1[32];
-#endif
   UInt      m_RefPicSetIdxL1[32];
     
@@ -837,18 +688,6 @@
   Bool       getRefPicListModificationFlagL1() { return m_bRefPicListModificationFlagL1; }
   Void       setRefPicListModificationFlagL1(Bool flag) { m_bRefPicListModificationFlagL1 = flag; }
-#if !H0137_0138_LIST_MODIFICATION
-  UInt       getNumberOfRefPicListModificationsL0() { return m_uiNumberOfRefPicListModificationsL0; }
-  Void       setNumberOfRefPicListModificationsL0(UInt nr) { m_uiNumberOfRefPicListModificationsL0 = nr; }
-  UInt       getNumberOfRefPicListModificationsL1() { return m_uiNumberOfRefPicListModificationsL1; }
-  Void       setNumberOfRefPicListModificationsL1(UInt nr) { m_uiNumberOfRefPicListModificationsL1 = nr; }
-  Void       setListIdcL0(UInt idx, UInt idc) { m_ListIdcL0[idx] = idc; }
-  UInt       getListIdcL0(UInt idx) { return m_ListIdcL0[idx]; }
-#endif
   Void       setRefPicSetIdxL0(UInt idx, UInt refPicSetIdx) { m_RefPicSetIdxL0[idx] = refPicSetIdx; }
   UInt       getRefPicSetIdxL0(UInt idx) { return m_RefPicSetIdxL0[idx]; }
-#if !H0137_0138_LIST_MODIFICATION
-  Void       setListIdcL1(UInt idx, UInt idc) { m_ListIdcL1[idx] = idc; }
-  UInt       getListIdcL1(UInt idx) { return m_ListIdcL1[idx]; }
-#endif
   Void       setRefPicSetIdxL1(UInt idx, UInt refPicSetIdx) { m_RefPicSetIdxL1[idx] = refPicSetIdx; }
   UInt       getRefPicSetIdxL1(UInt idx) { return m_RefPicSetIdxL1[idx]; }
@@ -867,7 +706,4 @@
   // access channel
   TComSPS*    m_pcSPS;
-#if !RPS_IN_SPS
-  TComRPSList* m_RPSList;
-#endif
   UInt        m_uiMaxCuDQPDepth;
   UInt        m_uiMinCuDQPSize;
@@ -876,12 +712,5 @@
   Int        m_iChromaQpOffset2nd;
 
-#if !RPS_IN_SPS
-  Bool        m_bLongTermRefsPresent;
-#endif
-
-#if !H0566_TLA
-  UInt        m_uiNumTlayerSwitchingFlags;            // num_temporal_layer_switching_point_flags
-  Bool        m_abTLayerSwitchingFlag[ MAX_TLAYER ];  // temporal_layer_switching_point_flag
-#endif
+
 
   Int         m_iSliceGranularity;
@@ -890,7 +719,5 @@
   UInt        m_uiBiPredIdc;              // Use of Weighting Bi-Prediction (B_SLICE)
 
-#if H0388
   Bool        m_OutputFlagPresentFlag;   // Indicates the presence of output_flag in slice header
-#endif
 
   Int      m_iTileBehaviorControlPresentFlag;
@@ -898,7 +725,4 @@
   Int      m_iColumnRowInfoPresent;
   Int      m_iUniformSpacingIdr;
-#if !REMOVE_TILE_DEPENDENCE
-  Int      m_iTileBoundaryIndependenceIdr;
-#endif
   Int      m_iNumColumnsMinus1;
   UInt*    m_puiColumnWidth;
@@ -907,16 +731,10 @@
   
   Int      m_iEntropyCodingMode; // !!! in PPS now, but also remains in slice header!
-#if !WPP_SIMPLIFICATION  
-  Int      m_iEntropyCodingSynchro;
-  Bool     m_bCabacIstateReset;
-#endif
   Int      m_iNumSubstreams;
 
   Bool     m_enableTMVPFlag;
 
-#if MULTIBITS_DATA_HIDING
   Int      m_signHideFlag;
   Int      m_signHidingThreshold;
-#endif
 
 #if CABAC_INIT_FLAG
@@ -927,10 +745,6 @@
 #endif
 #endif
-#if DBL_CONTROL
   Bool     m_DeblockingFilterControlPresent;
-#endif
-#if PARALLEL_MERGE
   UInt m_log2ParallelMergeLevelMinus2;
-#endif
 public:
   TComPPS();
@@ -951,22 +765,7 @@
   Void      setConstrainedIntraPred ( Bool b ) { m_bConstrainedIntraPred = b;     }
 
-#if !H0566_TLA
-  UInt      getNumTLayerSwitchingFlags()                                  { return m_uiNumTlayerSwitchingFlags; }
-  Void      setNumTLayerSwitchingFlags( UInt uiNumTlayerSwitchingFlags )  { assert( uiNumTlayerSwitchingFlags < MAX_TLAYER ); m_uiNumTlayerSwitchingFlags = uiNumTlayerSwitchingFlags; }
-
-  Bool      getTLayerSwitchingFlag( UInt uiTLayer )                       { assert( uiTLayer < MAX_TLAYER ); return m_abTLayerSwitchingFlag[ uiTLayer ]; }
-  Void      setTLayerSwitchingFlag( UInt uiTLayer, Bool bValue )          { m_abTLayerSwitchingFlag[ uiTLayer ] = bValue; }
-#endif
-
-#if !RPS_IN_SPS
-  Bool      getLongTermRefsPresent()         { return m_bLongTermRefsPresent; }
-  Void      setLongTermRefsPresent(Bool b)   { m_bLongTermRefsPresent=b;      }
-#endif
+
   Void      setSPS              ( TComSPS* pcSPS ) { m_pcSPS = pcSPS; }
   TComSPS*  getSPS              ()         { return m_pcSPS;          }
-#if !RPS_IN_SPS
-  Void      setRPSList          ( TComRPSList* RPSList ) { m_RPSList = RPSList; }
-  TComRPSList* getRPSList       ()         { return m_RPSList;        }
-#endif
   Void      setMaxCuDQPDepth    ( UInt u ) { m_uiMaxCuDQPDepth = u;   }
   UInt      getMaxCuDQPDepth    ()         { return m_uiMaxCuDQPDepth;}
@@ -985,8 +784,6 @@
   Void setWPBiPredIdc               ( UInt u )  { m_uiBiPredIdc = u;        }
 
-#if H0388
   Void      setOutputFlagPresentFlag( Bool b )  { m_OutputFlagPresentFlag = b;    }
   Bool      getOutputFlagPresentFlag()          { return m_OutputFlagPresentFlag; }
-#endif 
 
   Void    setTileBehaviorControlPresentFlag        ( Int i )             { m_iTileBehaviorControlPresentFlag = i;    }
@@ -998,8 +795,4 @@
   Void     setUniformSpacingIdr             ( Int i )           { m_iUniformSpacingIdr = i; }
   Int      getUniformSpacingIdr             ()                  { return m_iUniformSpacingIdr; }
-#if !REMOVE_TILE_DEPENDENCE
-  Void     setTileBoundaryIndependenceIdr   ( Int i )           { m_iTileBoundaryIndependenceIdr = i; }
-  Int      getTileBoundaryIndependenceIdr   ()                  { return m_iTileBoundaryIndependenceIdr; }
-#endif
   Void     setNumColumnsMinus1              ( Int i )           { m_iNumColumnsMinus1 = i; }
   Int      getNumColumnsMinus1              ()                  { return m_iNumColumnsMinus1; }
@@ -1034,19 +827,11 @@
   Void     setEntropyCodingMode(Int iEntropyCodingMode)       { m_iEntropyCodingMode = iEntropyCodingMode; }
   Int      getEntropyCodingMode()                             { return m_iEntropyCodingMode; }
-#if !WPP_SIMPLIFICATION
-  Void     setEntropyCodingSynchro(Int iEntropyCodingSynchro) { m_iEntropyCodingSynchro = iEntropyCodingSynchro; }
-  Int      getEntropyCodingSynchro()                          { return m_iEntropyCodingSynchro; }
-  Void     setCabacIstateReset(Bool bCabacIstateReset)        { m_bCabacIstateReset = bCabacIstateReset; }
-  Bool     getCabacIstateReset()                              { return m_bCabacIstateReset; }
-#endif
   Void     setNumSubstreams(Int iNumSubstreams)               { m_iNumSubstreams = iNumSubstreams; }
   Int      getNumSubstreams()                                 { return m_iNumSubstreams; }
 
-#if MULTIBITS_DATA_HIDING
   Void      setSignHideFlag( Int signHideFlag ) { m_signHideFlag = signHideFlag; }
   Void      setTSIG( Int tsig )                 { m_signHidingThreshold = tsig; }
   Int       getSignHideFlag()                    { return m_signHideFlag; }
   Int       getTSIG()                            { return m_signHidingThreshold; }
-#endif
 
   Void     setEnableTMVPFlag( Bool b )  { m_enableTMVPFlag = b;    }
@@ -1063,12 +848,8 @@
 #endif
 #endif
-#if DBL_CONTROL
   Void setDeblockingFilterControlPresent    ( Bool bValue )       { m_DeblockingFilterControlPresent = bValue; }
   Bool getDeblockingFilterControlPresent    ()                    { return m_DeblockingFilterControlPresent; }
-#endif
-#if PARALLEL_MERGE
   UInt getLog2ParallelMergeLevelMinus2      ()                    { return m_log2ParallelMergeLevelMinus2; }
   Void setLog2ParallelMergeLevelMinus2      (UInt mrgLevel)       { m_log2ParallelMergeLevelMinus2 = mrgLevel; }
-#endif
 };
 
@@ -1087,5 +868,4 @@
   Int*     getScalingListDefaultAddress   (UInt sizeId, UInt listId);                                                        //!< get default matrix coefficient
   Void     processDefaultMarix            (UInt sizeId, UInt listId);
-#if SCALING_LIST
   Void     setScalingListDC               (UInt sizeId, UInt listId, UInt u)   { m_scalingListDC[sizeId][listId] = u; }      //!< set DC value
   Int      getScalingListDC               (UInt sizeId, UInt listId)           { return m_scalingListDC[sizeId][listId]; }   //!< get DC value
@@ -1093,5 +873,4 @@
   Void     setUseDefaultScalingMatrixFlag (UInt sizeId, UInt listId, Bool b)   { m_useDefaultScalingMatrixFlag[sizeId][listId] = b;    } //!< set default matrix enabled/disabled in each matrix
   Bool     getUseDefaultScalingMatrixFlag (UInt sizeId, UInt listId)           { return m_useDefaultScalingMatrixFlag[sizeId][listId]; } //!< get default matrix enabled/disabled in each matrix
-#endif
   Void     processRefMatrix               (UInt sizeId, UInt listId , UInt refListId );
   Bool     xParseScalingList              (char* pchFile);
@@ -1100,8 +879,6 @@
   Void     init                    ();
   Void     destroy                 ();
-#if SCALING_LIST
   Int      m_scalingListDC               [SCALING_LIST_SIZE_NUM][SCALING_LIST_NUM]; //!< the DC value of the matrix coefficient for 16x16
   Bool     m_useDefaultScalingMatrixFlag [SCALING_LIST_SIZE_NUM][SCALING_LIST_NUM]; //!< UseDefaultScalingMatrixFlag
-#endif
   UInt     m_refMatrixId                 [SCALING_LIST_SIZE_NUM][SCALING_LIST_NUM]; //!< RefMatrixID
   Bool     m_scalingListPresentFlag;                                                //!< flag for using default matrix
@@ -1124,9 +901,5 @@
   Bool      getAlfEnabled ()          {return m_bAlfEnabled;     }  //!< get ALF enabled/disabled in APS
 
-#if LCU_SYNTAX_ALF
   AlfParamSet* getAlfParam   ()          {return m_alfParamSet;}
-#else
-  ALFParam* getAlfParam   ()          {return m_pAlfParam;       }  //!< get ALF parameters in APS
-#endif
   SAOParam* getSaoParam   ()          {return m_pSaoParam;       }  //!< get SAO parameters in APS
 
@@ -1151,8 +924,6 @@
   Bool      getScalingListEnabled ()          { return m_scalingListEnabled; }  //!< get ScalingList enabled/disabled in APS
   TComScalingList* getScalingList ()          { return m_scalingList; }         //!< get ScalingList class pointer in APS
-#if SAO_UNIT_INTERLEAVING
   Bool     getSaoInterleavingFlag() {return m_saoInterleavingFlag;}             //!< get SAO interleaving flag in APS
   Void     setSaoInterleavingFlag(Bool bVal) {m_saoInterleavingFlag = bVal;}    //!< set SAO interleaving flag in APS
-#endif
 
 private:
@@ -1161,9 +932,5 @@
   Bool        m_bAlfEnabled;  //!< ALF enabled/disabled in APS (true for enabled)
   SAOParam*   m_pSaoParam;    //!< SAO parameter object pointer 
-#if LCU_SYNTAX_ALF
   AlfParamSet*   m_alfParamSet;
-#else
-  ALFParam*   m_pAlfParam;    //!< ALF parameter object pointer
-#endif
   Bool        m_loopFilterOffsetInAPS;       //< offset for deblocking filter in 0 = slice header, 1 = APS
   Bool        m_loopFilterDisable;           //< Deblocking filter enabled/disabled in APS
@@ -1172,7 +939,5 @@
   Bool        m_scalingListEnabled;     //!< ScalingList enabled/disabled in APS (true for enabled)
   TComScalingList*     m_scalingList;   //!< ScalingList class pointer
-#if SAO_UNIT_INTERLEAVING
   Bool        m_saoInterleavingFlag;    //!< SAO interleaving flag
-#endif
 
 public:
@@ -1206,13 +971,9 @@
   bool       m_alfEnabledFlag;
   bool       m_saoEnabledFlag;
-#if SAO_UNIT_INTERLEAVING
   bool       m_saoInterleavingFlag;   ///< SAO interleaving flag
   bool       m_saoEnabledFlagCb;      ///< SAO Cb enabled flag
   bool       m_saoEnabledFlagCr;      ///< SAO Cr enabled flag
-#endif
   Int         m_iPPSId;               ///< picture parameter set ID
-#if H0388
   Bool        m_PicOutputFlag;        ///< pic_output_flag 
-#endif
   Int         m_iPOC;
   Int         m_iLastIDR;
@@ -1248,4 +1009,7 @@
 
   Bool        m_bCheckLDC;
+#if QC_TMVP_MRG_REFIDX_C0047
+  Int         m_aiNewRefIdx    [2]; 
+#endif
 
   //  Data
@@ -1265,5 +1029,5 @@
 #endif
 #if QC_IV_AS_LT_B0046
-  Bool                  m_bWasLongTerm[2][MAX_NUM_REF+1]; //was long-term picture
+  Bool        m_bWasLongTerm[2][MAX_NUM_REF+1]; //was long-term picture
 #endif
   TComSPS*    m_pcSPS;
@@ -1328,10 +1092,6 @@
 #endif
 
-#if H0111_MVD_L1_ZERO
   Bool       m_bLMvdL1Zero;
-#endif
-#if TILES_WPP_ENTRY_POINT_SIGNALLING
   Int         m_numEntryPointOffsets;
-#endif
 
   Int        m_viewId;
@@ -1340,9 +1100,17 @@
   Int        m_aaiCodedOffset[2][MAX_VIEW_NUM];
 
-#if SONY_COLPIC_AVAILABILITY|QC_MVHEVC_B0046
-  Int         m_iViewOrderIdx;
-#endif
 #if LGE_ILLUCOMP_B0045
   Bool        m_bApplyIC;
+#endif
+#if INTER_VIEW_VECTOR_SCALING_C0115|QC_MVHEVC_B0046
+  Bool       m_bIVScalingFlag;
+  Int        m_iViewOrderIdx;    // will be changed to view_id
+#endif
+
+#if MERL_VSP_C0152
+  TComPic*     m_apcRefPicBaseTxt;
+  TComPic*     m_apcRefPicBaseDepth;
+  Int*         m_aiShiftLUT;
+  Int          m_iShiftPrec;
 #endif
 
@@ -1380,13 +1148,10 @@
   Void      setAPSId        ( Int Id)          { m_iAPSId =Id;    } //!< set APS ID
   Int       getAPSId        ()                 { return m_iAPSId; } //!< get APS ID
-#if H0388
   Void      setPicOutputFlag( Bool b )         { m_PicOutputFlag = b;    }
   Bool      getPicOutputFlag()                 { return m_PicOutputFlag; }
-#endif
   Void      setAlfEnabledFlag(Bool s) {m_alfEnabledFlag =s; }
   Bool      getAlfEnabledFlag() { return m_alfEnabledFlag; }
   Void      setSaoEnabledFlag(Bool s) {m_saoEnabledFlag =s; }
   Bool      getSaoEnabledFlag() { return m_saoEnabledFlag; }
-#if SAO_UNIT_INTERLEAVING
   Void      setSaoInterleavingFlag(Bool s) {m_saoInterleavingFlag =s; } //!< set SAO interleaving flag
   Bool      getSaoInterleavingFlag() { return m_saoInterleavingFlag;  } //!< get SAO interleaving flag
@@ -1395,5 +1160,4 @@
   Void      setSaoEnabledFlagCr(Bool s) {m_saoEnabledFlagCr =s; }       //!< set SAO Cr enabled flag
   Bool      getSaoEnabledFlagCr() { return m_saoEnabledFlagCr; }        //!< get SAO Cr enabled flag
-#endif
   Void      setRPS          ( TComReferencePictureSet *pcRPS ) { m_pcRPS = pcRPS; }
   TComReferencePictureSet*  getRPS          () { return m_pcRPS; }
@@ -1430,7 +1194,4 @@
   Int       getRefViewId        ( RefPicList e, Int iRefIdx)    { return  m_aiRefViewIdList[e][iRefIdx]; }
   TComPic*  getTexturePic       () const                        { return  m_pcTexturePic; }
-#if SONY_COLPIC_AVAILABILITY
-  Int       getViewOrderIdx     ()                                  { return  m_iViewOrderIdx;              }
-#endif
   Int       getDepth            ()                              { return  m_iDepth;                     }
   UInt      getColDir           ()                              { return  m_uiColDir;                   }
@@ -1440,7 +1201,5 @@
 #endif
   Bool      getCheckLDC     ()                                  { return m_bCheckLDC; }
-#if H0111_MVD_L1_ZERO
   Bool      getMvdL1ZeroFlag ()                                  { return m_bLMvdL1Zero;    }
-#endif
   Int       getRefIdxOfLC       (RefPicList e, Int iRefIdx)     { return m_iRefIdxOfLC[e][iRefIdx];           }
   Int       getListIdFromIdxOfLC(Int iRefIdx)                   { return m_eListIdFromIdxOfLC[iRefIdx];       }
@@ -1482,7 +1241,4 @@
   Void      setRefViewId        ( Int i, RefPicList e, Int iRefIdx ) { m_aiRefViewIdList[e][iRefIdx] = i; }
   Void      setTexturePic       ( TComPic *pcTexturePic )       { m_pcTexturePic = pcTexturePic; }
-#if SONY_COLPIC_AVAILABILITY
-  Void      setViewOrderIdx     ( Int i )                       { m_iViewOrderIdx     = i;      }
-#endif
   Void      setNumRefIdx        ( RefPicList e, Int i )         { m_aiNumRefIdx[e]    = i;      }
   Void      setPic              ( TComPic* p )                  { m_pcPic             = p;      }
@@ -1499,7 +1255,5 @@
 #endif
   Void      setCheckLDC         ( Bool b )                      { m_bCheckLDC = b; }
-#if H0111_MVD_L1_ZERO
   Void      setMvdL1ZeroFlag     ( Bool b)                       { m_bLMvdL1Zero = b; }
-#endif  
 
   Bool      isIntra         ()                          { return  m_eSliceType == I_SLICE;  }
@@ -1539,20 +1293,12 @@
   Void setTLayer             ( UInt uiTLayer )             { m_uiTLayer = uiTLayer;                  }
 
-#if !H0566_TLA
-  Bool getTLayerSwitchingFlag()                            { return m_bTLayerSwitchingFlag;          }
-  Void setTLayerSwitchingFlag( Bool bValue )               { m_bTLayerSwitchingFlag = bValue;        }
-#endif
 
   Void setTLayerInfo( UInt uiTLayer );
   Void decodingMarking( TComList<TComPic*>& rcListPic, Int iGOPSIze, Int& iMaxRefPicNum ); 
   Void applyReferencePictureSet( TComList<TComPic*>& rcListPic, TComReferencePictureSet *RPSList);
-#if H0566_TLA && H0566_TLA_SET_FOR_SWITCHING_POINTS
+#if H0566_TLA_SET_FOR_SWITCHING_POINTS
   Bool isTemporalLayerSwitchingPoint( TComList<TComPic*>& rcListPic, TComReferencePictureSet *RPSList);
 #endif
-#if START_DECODING_AT_CRA
   Int       checkThatAllRefPicsAreAvailable( TComList<TComPic*>& rcListPic, TComReferencePictureSet *pReferencePictureSet, Bool outputFlag, Int pocRandomAccess = 0);
-#else
-  Int       checkThatAllRefPicsAreAvailable( TComList<TComPic*>& rcListPic, TComReferencePictureSet *pReferencePictureSet, Bool outputFlag);
-#endif
   Void      createExplicitReferencePictureSetFromReference( TComList<TComPic*>& rcListPic, TComReferencePictureSet *pReferencePictureSet);
 
@@ -1628,8 +1374,6 @@
   Int       getCABACinitIDC()         {return m_cabacInitIdc;    }  //!< get CABAC initial IDC number 
 #endif
-#if TILES_WPP_ENTRY_POINT_SIGNALLING
   Void      setNumEntryPointOffsets(Int val)  { m_numEntryPointOffsets = val;     }
   Int       getNumEntryPointOffsets()         { return m_numEntryPointOffsets;    }
-#endif
 
   Void setViewId( Int viewId )       { m_viewId = viewId;   }
@@ -1653,4 +1397,24 @@
   Bool      getApplyIC            ()  { return m_bApplyIC; }
   Void      xSetApplyIC           ();
+#endif
+#if QC_TMVP_MRG_REFIDX_C0047
+  Int       getNewRefIdx        ( RefPicList e )                { return  m_aiNewRefIdx[e];     }
+  Void      setNewRefIdx        ( RefPicList e, Int i )         { m_aiNewRefIdx[e]    = i;      }
+#endif
+#if INTER_VIEW_VECTOR_SCALING_C0115
+  Void setIVScalingFlag( Bool val )         { m_bIVScalingFlag = val;     }
+  Bool getIVScalingFlag()                   { return m_bIVScalingFlag;    }
+  Void setViewOrderIdx     ( Int i )        { m_iViewOrderIdx     = i;    }   // will be changed to view_id
+  Int  getViewOrderIdx     ()               { return  m_iViewOrderIdx;    }   // will be changed to view_id
+#endif
+
+#if MERL_VSP_C0152
+  TComPic*     getRefPicBaseTxt          ()                        { return  m_apcRefPicBaseTxt; }
+  Void         setRefPicBaseTxt          ( TComPic* RefPic)        { m_apcRefPicBaseTxt = RefPic; }
+  TComPic*     getRefPicBaseDepth        ()                        { return  m_apcRefPicBaseDepth; }
+  Void         setRefPicBaseDepth        ( TComPic* RefPic)        { m_apcRefPicBaseDepth = RefPic; }
+
+  Void setBWVSPLUTParam( Int *pShiftLUT, Int iLoG2LUTPrec) { m_aiShiftLUT = pShiftLUT; m_iShiftPrec = iLoG2LUTPrec; }
+  Void getBWVSPLUTParam( Int*&pShiftLUT, Int&iLoG2LUTPrec) { pShiftLUT = m_aiShiftLUT; iLoG2LUTPrec = m_iShiftPrec; }
 #endif
 
